# -*- coding: utf-8 -*- 
from __future__ import unicode_literals

import uno

def createUnoService(service, ctx):
    return ctx.ServiceManager.createInstanceWithContext(service, ctx)

from com.sun.star.script.provider import ScriptFrameworkErrorException
def xray(obj):
    '''Macro to call Basic XRay by Bernard Marcelly from Python.'''
    # ctx = XSCRIPTCONTEXT.getComponentContext()
    ctx = uno.getComponentContext()
    url = "vnd.sun.star.script:XRayTool._Main.Xray?language=Basic&location=application"
    mspf = createUnoService("com.sun.star.script.provider.MasterScriptProviderFactory", ctx)
    try:
        script = mspf.createScriptProvider('').getScript(url)
        script.invoke((obj,), (), ())
    except ScriptFrameworkErrorException:
        msgbox('Xray is not installed.\nPlease visit:\n'
               'http://www.openoffice.org/fr/Documentation/Basic',
               'Error', 'error')

def mri(target):
    # ctx = XSCRIPTCONTEXT.getComponentContext()
    ctx = uno.getComponentContext()
    mri = ctx.ServiceManager.createInstanceWithContext(
        "mytools.Mri",ctx)
    try:
        mri.inspect(target)
    except AttributeError:
        msgbox('MRI is not installed.\nPlease visit:\n'
               'http://extensions.services.openoffice.org',
               'Error', 'error')

from com.sun.star.awt.MessageBoxType import MESSAGEBOX, INFOBOX, ERRORBOX, WARNINGBOX, QUERYBOX
def msgbox(message, titre="Message", boxtype='message', boutons=1):
    # ctx = XSCRIPTCONTEXT.getComponentContext()
    ctx = uno.getComponentContext()
    types = {'message': MESSAGEBOX, 'info': INFOBOX, 'error': ERRORBOX,
             'warning': WARNINGBOX, 'query': QUERYBOX}
    tk = createUnoService("com.sun.star.awt.Toolkit", ctx)
    win = createUnoService("com.sun.star.frame.Desktop", ctx).getCurrentFrame().ContainerWindow
    box = tk.createMessageBox(win, types[boxtype], boutons, titre, message)
    return box.execute()
